//#define _POSIX_C_SOURCE 200112L

#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>

int main()
{
	// vytvori/otevre soubor
	int fd = open("foo.txt", O_RDONLY);
	if (!fd) {
		printf("Unable to open file.");
		exit(1);
	}

	// zjisteni velikosti souboru
	struct stat st;
	fstat(fd, &st);

	size_t length = st.st_size; // velikost dat
	printf("File size: %zi\n", length);

	// provede namapovani souboru do pameti
	char *data = mmap(NULL, length, PROT_READ, MAP_PRIVATE, fd, 0);
	if (data == MAP_FAILED) {
		printf("Unable to map file to memory.");
		exit(1);
	}

	// vypsani obsahu pameti (nemame zarucene, za posledni znak je \0
	for (int i = 0; i < length; i++) {
		putchar(data[i]);
	}

	// provede odmapovani souboru a jeho zavreni
	munmap(data, length);
	close(fd);
	return 0;
}
