#define _POSIX_C_SOURCE 200112L

#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>

int main()
{
	size_t length = 10; // velikost dat

	// vytvori/otevre soubor
	int fd = open("bar.txt", O_CREAT | O_RDWR, S_IRUSR | S_IWUSR);
	if (!fd) {
		printf("Unable to create file.");
		exit(1);
	}

	// nastavi souboru zadanou velikost
	ftruncate(fd, length);

	// provede namapovani souboru do pameti
	char *data = mmap(NULL, length, PROT_WRITE, MAP_SHARED, fd, 0);
	if (data == MAP_FAILED) {
		printf("Unable to map file to memory.");
		exit(1);
	}

	// zapise data do dane oblasti pameti
	strcpy(data, "123456789");

	// provede odmapovani souboru a jeho zavreni
	munmap(data, length);
	close(fd);
	return 0;
}
